options mprint mlogic symbolgen obs=max compress=yes nocenter;
    
%include "<program directory>/_includes.sas";
*-----------------------------------------------------;
* 000_nhsf_driver.sas                                 ;
*                                                     ;
* This is the driver program that defines macros used ; 
* in the 400 programs as well as libraries and files  ;
* used to run the 400 programs.                       ;
*                                                     ;
* Set Macro variables                                 ;
* (1) year: current MDS year                          ;
* (2) prior_year: prior MDS year                      ; 
* (3) yr2: current MDS 2 digit year                   ;
* (4) yrsf2: sample frame 2 digit year                ;
* (5) year_sf: sample frame year                      ;
*-----------------------------------------------------;

%let year = 2022;
%let prior_year = 2021;

%let yr2 = 22;
%let yrsf2 = 24;

%let year_sf = 2024;

*-----------------------------------------------------
Run 400_process_mds.sas
------------------------------------------------------;

title1 "Running 400_process_mds.sas";

libname out "<output directory>";

%let outdata = out._400_mds;

%_printto(prgname=400_process_mds);
%include "<program directory>/400_process_mds.sas";
title1;
%_printtoend(prgname=400_process_mds);

*-----------------------------------------------------
Run 410_avg_daily_census.sas
------------------------------------------------------;

title1 "Running 410_avg_daily_census.sas";

libname in "<input directory>" access = readonly;
libname ccn "<input directory>" access = readonly;

libname out "<output directory>";

%let indata = in._400_mds;
%let master_nh_file = ccn.all_nh_facilities;

%let outdata = out._410_avg_daily_census;

%_printto(prgname=410_avg_daily_census);
%include "<program directory>/410_avg_daily_census.sas";
title1;
%_printtoend(prgname=410_avg_daily_census);