/****************************************************************************************************************
   Program: 235_readin_shp_file.sas

   Purpose: This program uses proc mapimport to read in a shape file containing census tract boundaries for all 
            U.S. census tracts based on the 2010 census (we use the 2010 census because the most current RUCA codes 
            are still based on the 2010 census) and outputs the data in a SAS data set.

   Input files: US_tract_2018.shp

   Output files: us_tract_2018.sas7bdat
****************************************************************************************************************/
options nocenter mprint obs=max;

libname out "<output directory>";

%let in_path = <input directory>;
%let infile = US_tract_2018.shp;
%let outfile = out.us_tract_2018;

options validvarname=v7;

proc mapimport out=us_tract_2018 datafile="&in_path.\&infile.";
run;

data &outfile.;
   set us_tract_2018;
run;