/****************************************************************************************************************
   Program: 236_xform_shp_file.sas

   Purpose: This program uses proc gproject to transform the census tract boundaries in the shape file from census 
            tract polygon coordinates to latitude and longitude coordinates, and outputs the data in a SAS data set. 

   Input files: us_tract_2018.sas7bdat

   Output files: us_tract_2018_xform.sas7bdat
****************************************************************************************************************/
options nocenter mprint obs=max;

libname in "<input directory>" access=readonly;
libname out "<output directory>";

%let infile = in.us_tract_2018;
%let outfile = out.us_tract_2018_xform;

data tract_2018;
   set &infile.(keep=geoid segment x y);

   length st_fips $ 2;

   st_fips = substr(geoid,1,2);

run;

proc gproject data=tract_2018 out=tract_2018_xform from="ESRI:102003" to="EPSG:4326";
   id geoid segment;
run;

data &outfile.;
   set tract_2018_xform;
run;