*********************************************************************;
** Time Stamp, Proc Printto
*********************************************************************;

%macro timestamp_log(id=);
  %let actual_time = %sysfunc(putn(%sysfunc(datetime()),datetime22.));
  %put *--------------------------------------------------*;
  %put Timestamp: &id. &actual_time. ;
  %put *--------------------------------------------------*;
%mend timestamp_log;

%macro timer_start (varname = timer_start) ;

   %global &varname ;
   %let &varname = %sysfunc(datetime()) ;
   %put (&sysmacroName): Timer starting at %sysfunc(putn(&&&varname, dateampm.)) ;

%mend ;

%macro timer_end (varname = timer_start) ;
	
    data _null_;
      now = datetime() ;
      dur = datetime() - &&&varname ; *-- doing datetime() twice for most accuracy, probably overkill ;
      put "(&sysmacroName): Timer ending at " now dateampm. ;
      put 30*'-' / ' TOTAL DURATION:' dur time13.2 / 30*'-';
    run;

    %symdel &varname ;

%mend ;

%macro _printto(path=DEF,prgname=DEF,append=N);

	/*Unquote the automatic program file macro variable*/
	%let __Program_File = %sysfunc(dequote(&_SASPROGRAMFILE.)); 
	/*Check for user-specified program name and path. If not specified (DEF), then use the 
	  program name and path of currently executing program for log and list*/
	%if &prgname. = DEF %then %let prgname = %scan(&__Program_File.,-2,%str(/.));
	%if &path. = DEF %then %let path = %substr(&__Program_File.,1,%sysfunc(find(&__Program_File.,/,-999)));
		%else %do;
			%if %substr(&path.,%sysfunc(length(&path.)))~=/ %then
				%let path = &path./;
		%end;

	%let logpath = %trim(&path.)&prgname..log;
	%let lstpath = %trim(&path.)&prgname..lst;

	proc printto print = "&lstpath." 
		%if &append.=N %then %do;
			new 
		%end;
		;
	run;
	proc printto log = "&logpath." 
		%if &append.=N %then %do;
			new 
		%end;
		;
	run;
	ods listing;
%mend;

%macro _printtoend(path=DEF,prgname=DEF,append=N);
	proc printto; run;

	%let __Program_File = %sysfunc(dequote(&_SASPROGRAMFILE.)); 
	/*Check for user-specified program name and path. If not specified (DEF), then use the 
	  program name and path of currently executing program for log and list*/
	%if &prgname. = DEF %then %let prgname = %scan(&__Program_File.,-2,%str(/.));
	%if &path. = DEF %then %let path = %substr(&__Program_File.,1,%sysfunc(find(&__Program_File.,/,-999)));
		%else %do;
			%if %substr(&path.,%sysfunc(length(&path.)))~=/ %then
				%let path = &path./;
		%end;

	%let logpath = %trim(&path.)&prgname..log;
	%let lstoutpath = %trim(&path.)&prgname._logcheck.lst;

	proc printto print = "&lstoutpath." 
		%if &append.=N %then %do;
			new 
		%end;
		;
	run;

	proc printto; run;
%mend _printtoend;